#!/usr/bin/perl -w

use strict;

my ($MT_DIR,$PLUGIN_DIR,$PLUGIN_ENVELOPE);
eval
{
	require File::Basename;
	import  File::Basename('dirname');
	require File::Spec;

	$PLUGIN_DIR = $ENV{'PWD'};
	$PLUGIN_DIR = dirname($0)
		if ((!$PLUGIN_DIR) ||
		    (!File::Spec->file_name_is_absolute($PLUGIN_DIR)));
	$PLUGIN_DIR = dirname($ENV{'SCRIPT_FILENAME'}) 
		if (((!$PLUGIN_DIR) ||
		     (!File::Spec->file_name_is_absolute($PLUGIN_DIR)))
		    &&
		    ($ENV{SCRIPT_FILENAME}));
	die('The plug-in couldn\'t find its own location!')
		if ((!$PLUGIN_DIR) &&
		    (!File::Spec->file_name_is_absolute($PLUGIN_DIR)));
};
if ($@)
{
	print "Content-type: text/html\n\n$@"; 
	exit(0);
}
($MT_DIR,$PLUGIN_ENVELOPE) = $PLUGIN_DIR =~ m#(.*[\\/])(plugins[\\/].*)$#i;
unshift(@INC,$MT_DIR.'lib');
unshift(@INC,$MT_DIR.'extlib');


# Package *********************************************************************
package MT::App::Upcoming;


# Uses ************************************************************************
require MT::App;


# Globals *********************************************************************
our @ISA = ('MT::App');


# Code ************************************************************************

# Main ========================================================================
eval
{
	my $plug_Appl;

	$plug_Appl = MT::App::Upcoming->new(
		'Config'    => $MT_DIR.'mt.cfg',
		'Directory' => $MT_DIR);
	die(MT::App::Upcoming->errstr) if (!defined($plug_Appl));

	local $SIG{__WARN__} = sub { $plug_Appl->trace($_[0]) };
	$plug_Appl->run();
};
if ($@)
{
	print "Content-Type: text/html\n\n";
	print "Something horrible happened with the MT-Upcoming Plugin: $@";
}


# Subclassed code =============================================================
sub init
{
	my $plug_Appl;

	$plug_Appl = shift;
	return if (!$plug_Appl->SUPER::init(@_));

	$plug_Appl->add_methods(
		'default' => \&show_form,
		'save'    => \&save_form); 
	$plug_Appl->{'default_mode'}  = 'default';
	$plug_Appl->{'requires_login'} = 1;

	return $plug_Appl;   
}
sub config_params
{
	return ('upco_user','upco_pass','upco_keyy');
}
sub show_form
{
	my $plug_Appl;
	my %plug_Args;
	my $plug_Data;

	require MT::PluginData;

	# Set up
	$plug_Appl = shift;
	%plug_Args = @_;
	foreach ('MT-Upcoming','Upcoming')
	{
		if ((!$plug_Data) || (!keys(%{$plug_Data})))
		{
			$plug_Data = MT::PluginData->load(
			 {
				'plugin' => $_,
				'key'    => 'configuration'
			 });
			$plug_Data = $plug_Data?$plug_Data->data() || {}:{};
		}
	}

	# Check for permissions
	return $plug_Appl->error('You do not have permission to edit the '.
		'settings for the MT-Upcoming Plugin!')
		if ((!$plug_Appl->{'author'}) ||
		    (!$plug_Appl->{'author'}->can_create_blog()));

	# Set the values
	foreach ($plug_Appl->config_params())
	{
		$plug_Args{$_} = $plug_Data->{$_};
	}
	$plug_Appl->add_breadcrumb('MT-Upcoming Plugin');
	$plug_Appl->build_page('mt-upcoming.tmpl',\%plug_Args);
}
sub save_form
{
	my $plug_Appl;
	my $plug_Data;
	my $plug_Args;

	require MT::PluginData;

	# Set up
	$plug_Appl = shift;

	# Check for permission
	return $plug_Appl->error('You do not have permission to edit the '.
		'settings for the MT-Upcoming Plugin!')
		if ((!$plug_Appl->{'author'}) ||
		    (!$plug_Appl->{'author'}->can_create_blog()));
	return if (!$plug_Appl->validate_magic());

	# Save any new data
	$plug_Data = MT::PluginData->load(
	 {
		'plugin' => 'MT-Upcoming',
		'key'    => 'configuration'
	 });
	if (!$plug_Data)
	{
		$plug_Data = new MT::PluginData;
		$plug_Data->plugin('MT-Upcoming');
		$plug_Data->key('configuration');
	}
	$plug_Args = $plug_Data->data() || {};
	foreach ($plug_Appl->config_params())
	{
		$plug_Args->{$_} = $plug_Appl->{'query'}->param($_) || undef;
	}
	$plug_Data->data($plug_Args);
	die($plug_Data->errstr()) if (!$plug_Data->save());

	$plug_Appl->show_form('message' => 'Settings updated.');
}
1;
